/*
 * Copyright (c) 2024 ShinGeTsu Meter.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */
#pragma once

// GPOIO
#define LED_PIN      25
#define TA_RE1       9
#define TA_RE2       10
#define BUTTON_RST   11
#define BUTTON_COUNT 12
#define BUTTON_AUTO  13

// ロータリーエンコーダ移動方向判定用
#define ROTARY_DIRECTION \
    { 0, 1, -1, 0, -1, 0, 0, 1, 1, 0, 0, -1, 0, -1, 1, 0 }

// TA計算用定数
#define TA_MAX 6.5
#define TA_MIN 0.9412

// 時間
#define SAMPLE_WAIT_MS 100     // サンプリング間隔[mS]
#define UPDATE_RATIO   5       // LCDの更新比率  (SAMPLE_WAIT_MS × UPDATE_RATIO)[ms]間隔で更新
#define HIST_MS        1400    // 履歴保存帰還[mS]
#define RESET_WAIT_MS  500     // この期間連続して範囲外にであった場合リセットを実行
#define EVENT_BLOCK_MS 500     // 同じイベントの連続実行を抑止する時間

// TA関連
#define TA_HIST_SIZE (HIST_MS / SAMPLE_WAIT_MS)    // TA履歴サイズ
#define TA_BLOCK_TH  0.800                         // 履歴中のTA範囲がこれより大きい場合、自動リセット/TAカウントを抑制

// 電圧
#define METER_MAX_RATIO (1.0 / 13.0 * 37.0) //セット位置の電圧とリセット閾値の電圧の比率。13:セットのメモリ、37:リセット閾値のメモリ

// 表示モード
typedef enum {
    VIEW_1 = 0,
    VIEW_2,
    VIEW_3,
} view_t;
